import { watch as d, onMounted as m, ref as c, unref as y, watchEffect as g, onUpdated as W, reactive as S, toRef as p, getCurrentInstance as I, onUnmounted as P, nextTick as T, onActivated as C, readonly as R } from "vue";
import { isObject as E, deepMerge as O, getSlotsProps as o, isFunction as Q } from "@gx-design-vue/pro-utils";
function q(e, t, i) {
  d(t, (n, a) => {
    i ? i(n, a) && e() : e();
  }), m(() => {
    e();
  });
}
const h = (typeof window > "u" ? !1 : /iPad|iPhone|iPod/.test(navigator.platform) || navigator.platform === "MacIntel" && navigator.maxTouchPoints > 1) && !window.MSStream;
function N() {
  return h;
}
const b = typeof window > "u" ? !1 : h || window.safari !== void 0;
function z() {
  return b;
}
const s = {
  xs: {
    maxWidth: 575,
    matchMedia: "(max-width: 575px)"
  },
  sm: {
    minWidth: 576,
    maxWidth: 767,
    matchMedia: "(min-width: 576px) and (max-width: 767px)"
  },
  md: {
    minWidth: 768,
    maxWidth: 991,
    matchMedia: "(min-width: 768px) and (max-width: 991px)"
  },
  lg: {
    minWidth: 992,
    maxWidth: 1199,
    matchMedia: "(min-width: 992px) and (max-width: 1199px)"
  },
  xl: {
    minWidth: 1200,
    maxWidth: 1599,
    matchMedia: "(min-width: 1200px) and (max-width: 1599px)"
  },
  xxl: {
    minWidth: 1600,
    matchMedia: "(min-width: 1600px)"
  }
}, j = () => {
  let e = "md";
  return typeof window > "u" || (e = Object.keys(s).find((i) => {
    const { matchMedia: n } = s[i];
    return !!window.matchMedia(n).matches;
  })), e;
}, B = () => {
  const e = c(j());
  return Object.keys(s).forEach((t) => {
    const { matchMedia: i } = s[t], n = window.matchMedia(i);
    n.matches && (e.value = t), n.onchange = (a) => {
      a.matches && (e.value = t);
    };
  }), e;
};
function D(e, t, i) {
  const n = c(e());
  return d(t, (a, u) => {
    i ? i(a, u) && (n.value = e()) : n.value = e();
  }), n;
}
function F(e) {
  const t = typeof e == "function" ? e() : e, i = c(t);
  function n(a) {
    i.value = a;
  }
  return [i, n];
}
function G(e, t) {
  const { defaultValue: i, value: n = c() } = t || {};
  let a = typeof e == "function" ? e() : e;
  n.value !== void 0 && (a = y(n)), i !== void 0 && (a = typeof i == "function" ? i() : i);
  const u = c(a), f = c(a), [l, w] = F([f.value]);
  g(() => {
    let r = n.value !== void 0 ? n.value : u.value;
    t != null && t.postState && (r = t.postState(r, u.value)), f.value = r;
  }), d(l, () => {
    var v;
    const r = l.value[0];
    u.value !== r && ((v = t == null ? void 0 : t.onChange) == null || v.call(t, u.value, r));
  }, { deep: !0 });
  function x(r) {
    u.value = r;
  }
  function M(r) {
    x(r), w([f.value]);
  }
  return d(n, () => {
    u.value = n.value;
  }), [f, M, u];
}
function H(e, t) {
  const i = c(e[t]);
  return W(() => {
    const n = e[t];
    i.value !== n && (i.value = n);
  }), i;
}
function J(e, t) {
  const i = typeof e == "function" ? e() : e, n = S({
    data: i
  });
  function a(u) {
    u && E(u) && (n.data = O(n.data, u, {
      omitUndefined: (t == null ? void 0 : t.omitUndefined) ?? !0
    }));
  }
  return [p(n, "data"), a];
}
function L(e, t, i, n) {
  const a = c(o(e, t, i, n));
  return d(e.map((u) => () => i[u]), () => {
    a.value = o(e, t, i, n);
  }, { deep: 1 }), d(() => t, () => {
    a.value = o(e, t, i, n);
  }, { deep: 1 }), a;
}
function U(e) {
  I() && P(e);
}
function X(e, t, i = !1) {
  if (!Q(e))
    throw new Error("handle is not Function!");
  const { readyRef: n, stop: a, start: u } = A(t);
  return i ? e() : d(n, (f) => {
    f && e();
  }, { immediate: !1 }), { readyRef: n, stop: a, start: u };
}
function A(e) {
  const t = c(!1);
  let i;
  function n() {
    t.value = !1, i && window.clearTimeout(i);
  }
  function a() {
    n(), i = setTimeout(() => {
      t.value = !0;
    }, e);
  }
  return a(), U(n), { readyRef: t, stop: n, start: a };
}
function Y(e) {
  let t;
  m(() => {
    e(!1), T(() => {
      t = !0;
    });
  }), C(() => {
    t && e(!0);
  });
}
function Z() {
  const e = c(!1);
  return m(() => {
    e.value = !0;
  }), R(e);
}
export {
  Y as onMountedOrActivated,
  U as tryOnUnmounted,
  q as useEffect,
  N as useIsIos,
  Z as useIsMounted,
  z as useIsSafari,
  B as useMediaQuery,
  D as useMemo,
  G as useMergedState,
  H as usePickSlots,
  J as useReactiveState,
  L as useSlotsProps,
  F as useState,
  X as useTimeout
};
